
close all;

%%% 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Average fiscal efforts during the consolidation
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

Table = nan(15,7);
MFE_programs = [0.0075,0.0075,0.015,0.01,0.005,0.032,0.015,0.005,0.0075,0.0075,0.0125,0.0125,0.01,0.0075,0.02];





S_bal_D = S_bal_exante(6:21,:) - S_bal_exante(5:20,:);
for country = 1:15
S_bal_D_h = S_bal_D(:,country);
S_bal_D_h(isnan(S_bal_D_h))= 0;
S_bal_mean7 = mean(S_bal_D_h(1:7));
S_bal_D_h = S_bal_D_h(S_bal_D_h>0);

if size(S_bal_D_h(:),1) < 3
   S_bal_D_h = [S_bal_D_h(:);0];
end

Length_correction = size(S_bal_D_h,1);
S_bal_mean3 = mean(S_bal_D_h(1:3));
S_bal_mean_all = mean(S_bal_D_h(:));
Table(country,1) = S_bal_mean3;
Table(country,2) = S_bal_mean_all;
Table(country,3) = Length_correction;
Table(country,7) = country;
Table(country,8) = S_bal_mean7;

end;

S_bal_D = S_bal_expost(6:21,:) - S_bal_expost(5:20,:);
for country = [1:7,9:15]
S_bal_D_h = S_bal_D(:,country);
S_bal_D_h(isnan(S_bal_D_h))= 0;
S_bal_mean7 = mean(S_bal_D_h(1:7));
S_bal_D_h = S_bal_D_h(S_bal_D_h>0);

if size(S_bal_D_h(:),1) < 3
   S_bal_D_h = [S_bal_D_h(:);0];
end
   
Length_correction = size(S_bal_D_h,1);
S_bal_mean3 = mean(S_bal_D_h(1:3));
S_bal_mean_all = mean(S_bal_D_h(:));
Table(country,4) = S_bal_mean3;
Table(country,5) = S_bal_mean_all;
Table(country,6) = Length_correction;
Table(country,9) = S_bal_mean7;
end; 

Table_sorted = sortrows(Table,1);
labels_nums = Table_sorted(:,7);
labels_nums = labels_nums(:);

labels_sorted = {};
for country = 1:15
labels_sorted = [labels_sorted,{labels{labels_nums(country)}}];
end

figure(1);
Effortdata = 100*Table_sorted(:,[1,4]);
bar(Effortdata)
set(gca,'xticklabel',labels_sorted)
ylabel('Simulated SB adjustment 2009-2012 (% of GDP per annum)');
xlabel('Member state in the EDP');
set(gca,'FontSize',14)
legend('Early 2010 data','2016 data')


% figure(2);
% scatter(100*Table([1:2,4:5,7:14],1),100*MFE_programs([1:2,4:5,7:14]));
% a = [1:14]'; b = num2str(a); c = cellstr(b);
% dx = 0.0001*100; dy = 0.0001*100; % displacement so the text does not overlay the data points
% text(100*Table([1:2,4:5,7:14],1)+dx, 100*MFE_programs([1:2,4:5,7:14])+dy, labels([1:2,4:5,7:14]));
% 
% ylabel('EDP fiscal effort (% of GDP per annum)');
% xlabel('Simulator fiscal effort (% of GDP per annum)');
% xlim([0.4 1.6]);
% ylim([0.4 1.6]);
% set(gca,'FontSize',16)

figure(2);
scatter(100*Table([1:14],1),100*MFE_programs([1:14]));
a = [1:14]'; b = num2str(a); c = cellstr(b);
dx = 0.0001*100; dy = 0.0001*100; % displacement so the text does not overlay the data points
text(100*Table([1:14],1)+dx, 100*MFE_programs([1:14])+dy, labels([1:14]));

ylabel('EDP fiscal effort (% of GDP per annum)');
xlabel('Simulator fiscal effort (% of GDP per annum)');
xlim([0.4 1.7]);
ylim([0.4 3.6]);
set(gca,'FontSize',16)


figure(3);

SBmat = open('SBmat.mat');
SBmat = SBmat.SBmat;



x = [1:size(SBmat(:,1),1)];
hold on
plot(x,SBmat(:,2),'black-',...
    x,SBmat(:,3),'black--',...
    x,SBmat(:,4),'black:',...
    x,-0.5*ones(size(SBmat(:,1),1)),'red-','Linewidth',5);

ylabel('The structural balance (% of GDP)');
set(gca,'Xtick',x)
set(gca,'FontSize',16)
set(gca,'XTickLabel',SBmat(:,1))
xlim([min(x) max(x)])
legend('The median (14 countries in the EDP in 2010)','The 25th percentile (--)','The 75th percentile (--)','The minimum MTO')


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Debt dynamics
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


Debtpeak_exante = max(Debt_exante(5:end,:));
Debtpeak_expost = max(Debt_expost(5:end,:));

for country = 1:15
Debtpeak_Texante(country) = find(Debt_exante(5:end,country) == Debtpeak_exante(country),1)+8;
Debtpeak_Texpost(country) = find(Debt_expost(5:end,country) == Debtpeak_expost(country),1)+8;
end

Debtpeak_emp = max(Initvals_col_expost(5:end,1,:));
Debtpeak_emp = Debtpeak_emp(:);

for country = 1:15
Debtpeak_Temp(country) = find(Initvals_col_expost(5:end,1,country) == Debtpeak_emp(country),1)+8;
end

Initvals_SB_col_expost = -(Initvals_col_expost(:,4,:) + Initvals_col_expost(:,8,:));
S_bal_mean3_emp = (Initvals_SB_col_expost(8,:) - Initvals_SB_col_expost(5,:))/3;
S_bal_tot_emp = (Initvals_SB_col_expost(12,:) - Initvals_SB_col_expost(5,:))/7;




Table_comparison = [Table(:,4),S_bal_mean3_emp',Table(:,9),S_bal_tot_emp',Debtpeak_exante',Debtpeak_expost',Debtpeak_emp,Debtpeak_Texante',Debtpeak_Texpost',Debtpeak_Temp'];

Table_comparison_labels = num2str(Table_comparison); 
Table_comparison_labels = cellstr(Table_comparison_labels);
Table_comparison_labels = [labels',Table_comparison_labels];

Table_exantevsexpost = Table_comparison_labels;



Table_comparison = [Table(:,1),S_bal_mean3_emp',MFE_programs(1:15)',Table(:,8),S_bal_tot_emp',Debtpeak_exante',Debtpeak_emp,Debtpeak_Texante',Debtpeak_Temp'];
Table_comparison_labels = num2str(Table_comparison); 
Table_comparison_labels = cellstr(Table_comparison_labels);
Table_comparison_labels = [labels',Table_comparison_labels];

Table_2009forecast = Table_comparison_labels;


ngdp_expost = mean(Initvals_col_expost(5:11,5,:));
interest_expost = mean(Initvals_col_expost(5:11,6,:));
stockflow_expost = mean(Initvals_col_expost(5:11,7,:));
cyccomponent_expost = mean(Initvals_col_expost(5:11,8,:));
ngdp_exante = mean(Initvals_col(5:11,5,:));
interest_exante = mean(Initvals_col(5:11,6,:));
stockflow_exante = mean(Initvals_col(5:11,7,:));
cyccomponent_exante = mean(Initvals_col(5:11,8,:));


Table_comparison = 100*[ngdp_exante(:),ngdp_expost(:),interest_exante(:),interest_expost(:),stockflow_exante(:),stockflow_expost(:),cyccomponent_exante(:),cyccomponent_expost(:)];
Table_comparison_labels = num2str(Table_comparison); 
Table_comparison_labels = cellstr(Table_comparison_labels);
Table_comparison_labels = [labels',Table_comparison_labels];
Table_assumptions = Table_comparison_labels;




