%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Minimum fiscal effort (auxiliary code)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


function [datacube,DRtest,Debttest,Primdeftest,Deftest,MTOtest] = Loopf2(inputs,g_exo,r_exo,xvector,str_cor,sfa,cyc_gth,Inflation)

%%% Loopf2.m function takes the input vector, exogenous components of GPD
%%% and r as well as the estimation grid as inputs.
 xgridn=inputs(28);
 nvars=inputs(29);
 Length=inputs(30);

 
Debt = nan(Length,1);
STRDEFpGDP = nan(Length,1);
STRprimDEFpGDP = nan(Length,1);
GDP = nan(Length,1);
GDPg = nan(Length,1);
r = nan(Length,1);
DRtest = nan(Length,1);
Debttest = nan(Length,1);
Primdeftest = nan(Length,1);
Deftest = nan(Length,1);
MTOtest = nan(Length,1);
datacube = nan(Length,nvars,xgridn);

 
 tmin=inputs(1);
 Conslength=inputs(2);
 Debt(1)=inputs(3);
 Debt(2)=inputs(4);
 Debt(3)=inputs(5);
 Debt(4)=inputs(6);
 Debt(5)=inputs(7);
 GDP(1)=inputs(8);
 GDP(2)=inputs(9);
 GDP(3)=inputs(10);
 GDP(4)=inputs(11);
 GDP(5)=inputs(12);
 STRDEFpGDP(tmin)=inputs(13); %% For clarity, Deficit variable is renamed here
 STRprimDEFpGDP(1)=inputs(14); %% For clarity, PrimDeficit variable is renamed here
 STRprimDEFpGDP(2)=inputs(15);
 STRprimDEFpGDP(3)=inputs(16);
 STRprimDEFpGDP(4)=inputs(17);
 STRprimDEFpGDP(5)=inputs(18);
 GDPg(tmin)=inputs(19);
 r(tmin)=inputs(20);
 Deficittarget=inputs(21);
 fiscalm1=inputs(22);
 fiscalm2=inputs(23);
 fiscalm3=inputs(24);
 fiscalm4=inputs(25);
 fiscalm5=inputs(26);
 debtm=inputs(27);
 Timelimit=inputs(31);

%%% Notice: initial values for GDP are normalized to 1; Primdef = Primdef per
%%% GDP, Deficit = Deficit per GDP

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% It solves recursively the implied series of exogenous variables for each x:
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


tau = tmin + Conslength;

for xtest = 1:xgridn    

 
    
for t = (tmin+1):tau
    
x = xvector(xtest);    

Flexibility; %%% The algorithm checks whether the economic conditions provide reasons to deviate from the path.

GDPmin1 = GDP(t-1);
GDPgexo = g_exo(t);
Defmin1= STRDEFpGDP(t-1); %%% Notice: Deficit is structurally adjusted
STRDEFpGDPmin1 = STRDEFpGDP(t-1);
Debtmin4 = Debt(t-4);
Debtmin3 = Debt(t-3);
Debtmin2 = Debt(t-2);
Debtmin1 = Debt(t-1);
rexo = r_exo(t);
primDEFpGDPmin1_ = STRprimDEFpGDP(t-1) - str_cor(t-1);
primDEFpGDPmin2_ = STRprimDEFpGDP(t-2) - str_cor(t-2);
primDEFpGDPmin3_ = STRprimDEFpGDP(t-3) - str_cor(t-3);
primDEFpGDPmin4_ = STRprimDEFpGDP(t-4) - str_cor(t-4);
primDEFpGDPmin5_ = STRprimDEFpGDP(t-5) - str_cor(t-5);
pastshocks = fiscalm2*(primDEFpGDPmin1_-primDEFpGDPmin2_) + fiscalm3*(primDEFpGDPmin2_-primDEFpGDPmin3_) + fiscalm4*(primDEFpGDPmin3_-primDEFpGDPmin4_) + fiscalm5*(primDEFpGDPmin4_-primDEFpGDPmin5_);

period = t-tmin;

str_cor_ = str_cor(t);
sfa_ = sfa(t);
STRDEFpGDP_ = x+Defmin1;
r_ = (rexo + debtm*(Debtmin1/GDPmin1));

% PD_ = DEF_ - r_*Debtmin1;
% PD_ = GDP_*STRDEFpGDP_ - r_*Debtmin1;
% 
% GDPg_ = 1+ GDPgexo + fiscalm1*(PD_/GDPmin1 - str_cor_ - primDEFpGDPmin1_) + pastshocks;
% GDP_ = GDPmin1*(1+ GDPgexo + fiscalm1*(PD_/GDPmin1 - primDEFpGDPmin1_)+ pastshocks);
% 
% aux1_ = GDPmin1*(1+ GDPgexo - fiscalm1*(str_cor_ + primDEFpGDPmin1_)+ pastshocks);
% GDP_ = aux1_ + GDPmin1*fiscalm1*(PD_/GDPmin1);
% 
% GDPmin1*fiscalm1*(PD_/GDPmin1) = fiscalm1*(GDP_*STRDEFpGDP_ - r_*Debtmin1)
% = (fiscalm1*STRDEFpGDP_)*GDP_ - fiscalm1*r_*Debtmin1
% 
% (1 - fiscalm1*STRDEFpGDP_)*GDP_ = aux1 - fiscalm1*r_*Debtmin1

aux1_ = GDPmin1*(1+ GDPgexo - fiscalm1*(str_cor_ + primDEFpGDPmin1_)+ pastshocks);
GDP_ = (aux1_ - fiscalm1*r_*Debtmin1)/(1 - fiscalm1*STRDEFpGDP_);
STRprimDEFpGDP_ = STRDEFpGDP_ - r_*Debtmin1/GDP_;
Debt_ = Debtmin1 + (STRDEFpGDP_ - str_cor_)*GDP_ + sfa_*GDP_; %%% Notice: Debt is not structurally adjusted and thus the structural correction enters its accumulation equation.

GDP(t) = GDP_;
STRprimDEFpGDP(t) = STRprimDEFpGDP_; 
Debt(t) = Debt_;  %%% Notice: Debt is not structurally adjusted
STRDEFpGDP(t) = STRDEFpGDP_;
r(t) = r_;


end

%%% It collects values of endogenous variables into a datacube

%%datacube(:,1,xtest) = GDP(:,1);
%%datacube(:,2,xtest) = Debt(:,1)./GDP(:,1);
%%datacube(:,3,xtest) = STRprimDEFpGDP(:,1); 
%%datacube(:,4,xtest) = STRDEFpGDP(:,1);
%%datacube(:,5,xtest) = r(:,1);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Recursive procedure ends
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%




%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% We next calculate various test measures
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%%% We calculate three debt reduction rules; backward-looking,
%%% forward-looking and the cyclically corrected debt measure. We calculate
%%% the forward-looking element for all programs, while the other rules are
%%% informative only for programs lasting at least Time-limit (3 years in the
%%% benchmark simulation) years. 
%%% 
%%% The three-year rule applies for programs lasting more than Time-limit (3) years. 
%%% For program that lasts exactly Time-limit years we relax the rule. 
%%% That is, we allow the possibility that the initial deficit is below 3
%%% percent.
%%% 


%%%
%%%
%%%
%%% Backward-looking debt reduction benchmark
%%%
%%%
%%%


DRbench = 0.6 + 0.95/3*(Debt(tau-1)/GDP(tau-1)-0.60) + 0.95^2/3*(Debt(tau-2)/GDP(tau-2)-0.60) + 0.95^3/3*(Debt(tau-3)/GDP(tau-3)-0.60); %% DRbench provides a benchmark of debt level in period t as a function of past debt levels that satisfies the 5 % debt reduction effort.


%%%
%%%
%%% Forward-looking debt reduction benchmark: We assume similar to DG
%%% ECFIN (2013) "Occasional papers 151" that the country maintains its
%%% period tau structural deficit for the next two years.
%%%
%%%

for t = (tau+1):(tau+2)
   
GDPmin1 = GDP(t-1);
GDPgexo = g_exo(t);
Defmin1= STRDEFpGDP(t-1); %%% Notice: Deficit is structurally adjusted
Debtmin4 = Debt(t-4);
Debtmin3 = Debt(t-3);
Debtmin2 = Debt(t-2);
Debtmin1 = Debt(t-1);
rexo = r_exo(t);
primDEFpGDPmin1_ = STRprimDEFpGDP(t-1) - str_cor(t-1);
primDEFpGDPmin2_ = STRprimDEFpGDP(t-2) - str_cor(t-2);
primDEFpGDPmin3_ = STRprimDEFpGDP(t-3) - str_cor(t-3);
primDEFpGDPmin4_ = STRprimDEFpGDP(t-4) - str_cor(t-4);
primDEFpGDPmin5_ = STRprimDEFpGDP(t-5) - str_cor(t-5);
pastshocks = fiscalm2*(primDEFpGDPmin1_-primDEFpGDPmin2_) + fiscalm3*(primDEFpGDPmin2_-primDEFpGDPmin3_) + fiscalm4*(primDEFpGDPmin3_-primDEFpGDPmin4_) + fiscalm5*(primDEFpGDPmin4_-primDEFpGDPmin5_);

period = t-tmin;

str_cor_ = str_cor(t);
sfa_ = sfa(t);
STRDEFpGDP_ = STRDEFpGDP(tau);  %%% Fix structural deficit to the level at tau.
r_ = (rexo + debtm*(Debtmin1/GDPmin1));

%%%% What is aux1_?
% PD_ = DEF_ - r_*Debtmin1;
% PD_ = GDP_*STRDEFpGDP_ - r_*Debtmin1;
% 
% GDPg_ = 1+ GDPgexo + fiscalm1*(PD_/GDPmin1 - str_cor_ - primDEFpGDPmin1_) + pastshocks;
% GDP_ = GDPmin1*(1+ GDPgexo + fiscalm1*(PD_/GDPmin1 - primDEFpGDPmin1_)+ pastshocks);
% 
% aux1_ = GDPmin1*(1+ GDPgexo - fiscalm1*(str_cor_ + primDEFpGDPmin1_)+ pastshocks);
% GDP_ = aux1_ + GDPmin1*fiscalm1*(PD_/GDPmin1);
% 
% GDPmin1*fiscalm1*(PD_/GDPmin1) = fiscalm1*(GDP_*STRDEFpGDP_ - r_*Debtmin1)
% = (fiscalm1*STRDEFpGDP_)*GDP_ - fiscalm1*r_*Debtmin1
% 
% (1 - fiscalm1*STRDEFpGDP_)*GDP_ = aux1 - fiscalm1*r_*Debtmin1

aux1_ = GDPmin1*(1+ GDPgexo - fiscalm1*(str_cor_ + primDEFpGDPmin1_)+ pastshocks);
GDP_ = (aux1_ - fiscalm1*r_*Debtmin1)/(1 - fiscalm1*STRDEFpGDP_);
STRprimDEFpGDP_ = STRDEFpGDP_ - r_*Debtmin1/GDP_;
Debt_ = Debtmin1 + (STRDEFpGDP_ - str_cor_)*GDP_ + sfa_*GDP_; %%% Notice: Debt is not structurally adjusted and thus the structural correction enters its accumulation equation.

GDP(t) = GDP_;
STRprimDEFpGDP(t) = STRprimDEFpGDP_; 
Debt(t) = Debt_;  %%% Notice: Debt is not structurally adjusted
STRDEFpGDP(t) = STRDEFpGDP_;
r(t) = r_;


end

datacube(:,1,xtest) = GDP(:,1);
datacube(:,2,xtest) = Debt(:,1)./GDP(:,1);
datacube(:,3,xtest) = STRprimDEFpGDP(:,1); 
datacube(:,4,xtest) = STRDEFpGDP(:,1);
datacube(:,5,xtest) = r(:,1);

%%%
%%%
%%%
%%% Forward-looking debt reduction benchmark
%%%
%%%
%%%

DRbench2 = 0.6 + 0.95/3*(Debt(tau+1)/GDP(tau+1)-0.60) + 0.95^2/3*(Debt(tau)/GDP(tau)-0.60) + 0.95^3/3*(Debt(tau-1)/GDP(tau-1)-0.60);

%%%
%%%
%%%
%%% Cyclically corrected debt
%%%
%%%
%%%



DRbench3 = (Debt(tau) - str_cor(tau)*GDP(tau) - str_cor(tau-1)*GDP(tau-1) - str_cor(tau-2)*GDP(tau-2))/(GDP(tau-3)*cyc_gth(tau));

%%% Notice that GDP(tau)*cyc_gth(tau) =
%%% (GDP(tau-2)*cyc_gth(tau)*(GDP(tau)/GDP(tau-2))); (cyc_gth measures the relative size of potential growth and actual growth)


%%%
%%%
%%%
%%% Program with debt over 60% is in compliance with the rules if any of
%%% the conditions is fulfilled. (DRtest)
%%%
%%%
%%%


DRtest_aux(1) = Debt(tau)/GDP(tau) - DRbench;
DRtest_aux(2) = Debt(tau+2)/GDP(tau+2) - DRbench2;
DRtest_aux(3) = DRbench3 - 0.6;

if Conslength < Timelimit
   DRtest_aux(1) = 9999;
   DRtest_aux(3) = 9999;
end


%DRtest(xtest) = min(DRtest_aux);
DRtest(xtest) = DRtest_aux(2);

%%%% if Conslength <= Timelimit
%%%%   Deftest(xtest) = 9999;
%%%%else
   if Conslength > Timelimit
   Deftest_ = min(STRDEFpGDP(tmin:(tau-Timelimit),1) - str_cor(tmin:(tau-Timelimit)));
   Deftest(xtest) = Deftest_ - 0.03;
   else
   Deftest(xtest) = 9999;    
   end
   
%%%   Deftest(xtest) = STRDEFpGDP(tau-Timelimit,1) - str_cor(tau-Timelimit) - 0.03; 
%%%% end



Debttest(xtest) = Debt(tau)/GDP(tau)-0.60; %%% Debt ratio test
Primdeftest(xtest) = STRprimDEFpGDP(tau)*GDP(tau)/tau; %%% Size of primary deficit at the last year for comparisons of s2


MTOtest(xtest) =  Deficittarget - STRDEFpGDP(tau);


    



% The three year rule:





end

